## Unified Distributed Environment (UDE)

UDE is an open-source Python library for virtualizing reinforcement learning environments. It supports seamless offload and provides a uniform API to control the flow and life-cycle of the simulation environments.

## Installation

To install the UDE toolkit, run the `pip install ude`command.

Python 3.6, 3.7, 3.8, and 3.9 are supported on Linux, Windows, and macOS.

## Citation

UDE whitepaper is available at https://arxiv.org/abs/2205.06946.
If you reference or use UDE in your research, please cite:

```
@misc{la2022unified,
      title={Unified Distributed Environment}, 
      author={Woong Gyu La and Sunil Muralidhara and Lingjie Kong and Pratik Nichat},
      year={2022},
      eprint={2205.06946},
      archivePrefix={arXiv},
      primaryClass={cs.LG}
}
```

## License

The source code is released under [Apache 2.0](https://aws.amazon.com/apache-2-0/).

## Resources

* [UDE ROS Bridge](https://github.com/aws-deepracer/ude-ros-bridge)
* [UDE OpenAI-Gym Bridge](https://github.com/aws-deepracer/ude-gym-bridge)